---
title: FileSystemFileHandle.createWritable()
slug: Web/API/FileSystemFileHandle/createWritable
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemFileHandle
  - Method
  - stream
  - working with files
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>createWritable()</code></strong> method of the {{domxref("FileSystemFileHandle")}} interface creates a {{domxref('FileSystemWritableFileStream')}} that can be used to write to a file.</p>

<p>Any changes made through the stream won’t be reflected in the file represented by the file handle until the stream has been closed. This is typically implemented by writing data to a temporary file, and only replacing the file represented by file handle with the temporary file when the writable filestream is closed.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>FileSystemWritableFileStream</var> = FileSystemFileHandle.createWritable();</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>FileSystemCreateWritableOptions</dt>
 <dd>An object representing options to pass into the method. Options are:
 <ul>
  <li><code>keepExistingData</code>: If <code>false</code> or not specified, the temporary file starts out empty, otherwise the existing file is first copied to this temporary file.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A Promise which resolves with a {{domxref('FileSystemWritableFileStream')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>NotAllowedError</dt>
 <dd>Thrown if the {{domxref('PermissionStatus.state')}} for the handle is not <code>'granted'</code> in <code>readwrite</code> mode.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following asynchronous function writes the given contents to the file handle, and thus to disk.</p>

<pre class="brush: js notranslate">async function writeFile(fileHandle, contents) {
  // Create a FileSystemWritableFileStream to write to.
  const writable = await fileHandle.createWritable();

  // Write the contents of the file to the stream.
  await writable.write(contents);

  // Close the file and write the contents to disk.
  await writable.close();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access','#dom-filesystemfilehandle-createwritable','createWritable')}}</td>
   <td>{{Spec2('File System Access')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemFileHandle.createWritable")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
